/*
   program to read BYU SIR image files and write out as various file types:
   	.bmp

   Written by Vaughn C. Clayton 15 Aug, 2000
   Using code written by DGL Aug. 8, 1997

   Written in ANSI C.  Define or undefine SWAP based on machine byte order

*/

#define SWAP 1                /* swap bytes (little endian: dec, pc) */
#undef SWAP                   /* no byte swapping (big endian: HP,SUN) */

#ifdef HPUX
#include <stdlib.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "libsir.h"
#include "coord.h"

#define rnd(a) ((a) >= 0 ? floor((a)+0.5L) : ceil((a)-0.5L))



#define REL_BEGIN 0           /* fseek relative to beginning of file */
#define SIR_HEADER_SIZE 512   /* SIR file header size in bytes */
#define BUFFER 6000           /* space in buffer */ 

/*
int main(int argc, char **argv)
{
  FILE *imf;
  int i, j, k;
  int ix, iy, ix1, iy1;
  float x, y, x1, y1, thelon, thelat, alon, alat, am, amag;
  char outfname[80];

  char rtab[256], gtab[256], btab[256];
	
  float smin, smax;
  float s, soff;
  float scale, scaleoffset;


  float v_min, v_max, anodata;
  int nsx, nsy, ioff, iscale, iyear, isday, ismin, ieday, iemin;
  int iregion, itype, nhead, ndes, nhtype, idatatype, ldes, nia;
  int ipol, ifreqhm, ispare1;
  char title[101], sensor[41], crproc[101], type[139], tag[101], crtime[29];
  float xdeg, ydeg, ascale, bscale, a0, b0;
  int iopt;

#define MAXDES 1024
  char descrip[MAXDES+1];
#define MAXI 128
  short iaopt[MAXI];

  float *stval;

  int ierr;
  short *a;
  float *data;
  int nlines, width;
  struct sirheader h;

  union 
  {
    short i2[2];
    float f2;
  } un;

  fprintf(stdout,"BYU SIR image conversion tool\n") ;
  if(argc < 3) {
    fprintf(stdout,"\nusage: %s sir_in bmp_out <dmin> <dmax> <ctab>\n\n",argv[0]);
    fprintf(stdout," input parameters:\n");
    fprintf(stdout,"   sir_in  =  input SIR file\n");
    fprintf(stdout,"   bmp_out =  output bmp file\n");
    fprintf(stdout,"   dmin    =  min saturation value (optional,def=vmin)\n");
    fprintf(stdout,"   dmax    =  max saturation value (optional,def=vmax)\n");
    fprintf(stdout,"   ctab    =  color table file (optional,def=greyscale)\n"); 
    return(0);
  }

  imf = fopen(argv[1],"r"); 
  if (imf == NULL) {
     fprintf(stdout,"ERROR: cannot open input file: %s\n",argv[1]); 
     exit(-1);
  }




  ierr = read_sir_header(imf, &nhead, &ndes, &nhtype,
		    &idatatype, &nsx, &nsy, 
		    &xdeg, &ydeg, &ascale, &bscale, &a0, &b0, 
		    &ioff, &iscale, &iyear, &isday, &ismin, &ieday, &iemin, 
		    &iregion, &itype, &iopt, &ipol, &ifreqhm, &ispare1,
		    &anodata, &v_min, &v_max,
		    sensor, title, type, tag, crproc, crtime, 
		    MAXDES, descrip, &ldes, MAXI, iaopt, &nia);  
  if (ierr < 0) {
     fprintf(stdout,"*** Error reading SIR header from file '%s'\n",argv[1]);
     exit(-1);
  }
  
  fprintf(stdout,"\nSIR file header: '%s'\n",argv[1]);
  print_head(nhead, ndes, nhtype, idatatype, nsx, nsy, 
	     xdeg, ydeg, ascale, bscale, a0, b0, 
	     ioff, iscale, iyear, isday, ismin, ieday, iemin, 
	     iregion, itype, iopt, ipol, ifreqhm, ispare1,
	     anodata, v_min, v_max,
	     sensor, title, type, tag, crproc, crtime, 
	     descrip, ldes, iaopt, nia);  


  
	rewind(imf);
	ierr = read_sir_header_2(imf, &h);
	if(ierr<0)
	{
		printf("Error in read_sir_header_2\n");
		exit(-1);
	}




	fprintf(stdout,"\n\nSIR file header(2): '%s'\n",argv[1]);
	print_head(h.num_headers, h.num_desc, h.headertype, h.datatype, 
		h.xpixels, h.ypixels, h.xdegrees, h.ydegrees, h.xscale, h.yscale,
		h.olon, h.olat, h.ioff, h.iscale, 
		h.year, h.sday, h.smin, h.eday, h.emin, 
		h.region, h.image_type, h.proj_type, h.polarization, h.frequency,h.spare1,
		h.nodata, h.v_min, h.v_max,
		h.sensor, h.title, h.type, h.tag, h.crproc, h.crtime, 
		h.description, h.len_desc, (short*)"\0", h.num_opts);  


	data = (float*)malloc(sizeof(float)*h.xpixels*h.ypixels);
	ierr = read_sir_data(imf, data);

	fclose(imf);
	return(0);
}
*/

/*	    
int read_sir_header(FILE *imf, int *nhead, int *ndes, int *nhtype,
		    int *idatatype, int *nsx, int *nsy, 
		    float *xdeg, float *ydeg, 
		    float *ascale, float *bscale, float *a0, float *b0, 
		    int *ioff, int *iscale, int *iyear, 
		    int *isday, int *ismin, int *ieday, int *iemin, 
		    int *iregion, int *itype, int *iopt,
		    int *ipol, int *ifreqhm, int *ispare1,
		    float *anodata, float *v_min, float *v_max,
		    char *sensor, char *title, char *type, char *tag,
		    char *crproc, char *crtime, int maxdes, 
		    char *descrip, int *ldes, int maxi, short *iaopt,
		    int *nia)
{*/
   /* v2 read header of BYU SIR file --- written by D.Long March 1997 */

/*  Header consists of a variable number of 512 byte blocks.  The
    block contains scaling information and strings:
    note that character strings may not be null terminated in file

    The first block consists of 256 short integers.  Indexing them
    from 1..256 in an array temp, they contain:

	temp(1)	= nsx			! pixels in x direction
	temp(2) = nsy			! pixels in y direction
        temp(3) <= xdeg			! span of deg in x
	temp(4) <= ydeg			! span of deg in y
	temp(5) = nhtype                ! header type (old<15)
	temp(6) <= ascale               ! x scaling
	temp(7) <= bscale               ! y scaling
	temp(8) <= a0                   ! x (lon) origin
         note: longitudes should be in the range -180 to 180
	temp(9) <= b0                   ! y (lat) origin
	temp(10) = ioff			! offset to be added to scaled val
	temp(11) = iscale		! scale factor ival=(val-ioff)/iscale
	temp(12) = iyear		! year for data used
	temp(13) = isday		! starting JD
	temp(14) = ismin		! time of day for first data (in min)
	temp(15) = ieday		! ending JD
	temp(16) = iemin		! time of day for last data (in min)
	temp(17) = iopt			! projection type
					!  -1 = no projection, image only
					!   0 = rectalinear lat/lon
					!   1 = lambert equal area
					!   2 = lambert equal area (local rad)
					!   5 = polar stereographic
					!  11 = EASE north equal area grid
					!  12 = EASE south equal area grid
					!  13 = EASE cylindrical grid
	temp(18) = iregion		! region id code
	temp(19) = itype		! image type code
                                        ! standard values: 0=unknown or n/a
                                        ! 1 = scatterometer A (dB)
                                        ! 2 = scatterometer B (dB/deg)
                                        ! 3 = radiometer Tb (K)
                                        ! 9 = topography (m)
	temp(20)-temp(39) 40 chars of sensor
        temp(40) = 0 
        temp(41) = nhead                ! number of 512 byte header blocks
        temp(42) = ndes                 ! number of 512 byte blocks description
        temp(43) = ldes                 ! number of bytes of description
        temp(44) = nia                  ! number of optional integers
        temp(45) = ipol                 ! polarization (0=n/a,1=H,2=V)
        temp(46) = ifreqhm              ! frequency in 100's of MHz
        temp(47) = ispare1              ! spare
        temp(48) = idatatype            ! data type code 0,2=i*2,1=i*1,4=f

       the value of idata type determines how data is stored and how
       anodata, vmin, and vmax are stored.

        if idatatype = 1 data is stored as bytes and minv=128
        if idatatype = 2 data is stored as 2 byte integers and minv=32767
        if idatatype = 4 data is stored as IEEE floating point

        if idatatype = 1,2 anodata,vmin,vmax are stored as 2 byte integers
         in temp(49)..temp(51)  minv, ioff and iscal used to convert
         integers or bytes into floating point values
         nodata, vmin, and vmax must be representable with ioff and iscale
            temp(*) = (value-ioff)*iscale-minv
            value = float(temp(*)+minv)/float(iscale)+ioff
        idatatype=2 is considered the SIR standard format

        if idatatype = f anodata,vmin,vmax are stored as floating points
         in temp(52)..temp(57) and minv, ioff and iscale are ignored here
         and when reading the file.
         floating point numbers are NOT standard across platforms and
         is not recommended

        temp(49) <= anodata            ! value representing no data
        temp(50) <= vmin               ! minimum useful value from creator prg
        temp(51) <= vmax               ! maximum useful value from creator prg
        temp(52,53) = anodata          ! IEEE floating value of no data
        temp(54,55) = vmin             ! IEEE floating minimum useful value
        temp(56,57) = vmax             ! IEEE floating maximum useful value

	temp(58)-temp(126) 138 chars of type
        temp(127) = 0 
        temp(128) = 0 
	temp(129)-temp(168) 80 chars of title
        temp(169) = 0 
	temp(170)-temp(189) 40 chars of tag
        temp(190) = 0 
	temp(191)-temp(240) 100 chars of crproc
        temp(241) = 0 
	temp(242)-temp(255) 28 chars of crtime
        temp(256) = 0 

     optional header blocks:

	ndes header blocks of 512 bytes: chars of description
	nhead-ndes-1 header blocks of 512 bytes: values of iaopt
        by convention, first value iaopt is a code telling how to interpret
        the rest of the array if nia>0

        remainder of file is image data in a multiple of 512 byte blocks
        two byte integer and byte scaling is
          intval = (fvalue-ioff)*iscale-minv
          fvalue = float(intval+minv)/float(iscale)+ioff

*/
/*
   short in, temp[256];
   int nch,i;
   float f,soff;

   union 
     {
       short i2[2];
       float f2;
   } un;

   rewind(imf);


   if (fread(temp, sizeof(short), 256, imf) == 0) return(-1);
#ifdef SWAP
   swap(temp, 256);
#endif


   *nsx = temp[0];
   *nsy = temp[1];
   *xdeg = 0.01 * temp[2];
   *ydeg = 0.01 * temp[3];
   *nhtype = temp[4];
   if (*nhtype < 20) *nhtype=1;
   *ascale = 0.001 * temp[5];
   *bscale = 0.001 * temp[6];
   *a0 = 0.01 * temp[7];
   *b0 = 0.01 * temp[8];
   *ioff = temp[9];
   *iscale = temp[10];
   if (*iscale == 0) *iscale=1;
   *iyear = temp[11];
   *isday = temp[12];
   *ismin = temp[13];
   *ieday = temp[14];
   *iemin = temp[15];
   *iopt  = temp[16];
   *iregion = temp[17];
   *itype = temp[18];

   switch (*iopt){
    case -1:
      *xdeg = *xdeg * 10.0;
      *ydeg = *ydeg * 10.0;
      break;
    case 0:
      *xdeg = *xdeg + 100.0;
      break;
    case 1:
    case 2:
      *ascale = 1./ *ascale;
      *bscale = 1./ *bscale;
      *a0 = *a0 * 100.0;
      *b0 = *b0 * 100.0;
      break;
    case 5:
      *ascale = *ascale * 10.0;
      *bscale = *bscale * 10.0;
      *a0 = *a0 *100.0;
      *b0 = *b0 *100.0;
      *xdeg = *xdeg + 100.0;
      break;
    case 11:
    case 12:
    case 13:
      *ascale = (float) (((double) *ascale) * (double) 2.0 * 6371.228/25.067525);
      *bscale = (float) (((double) *bscale) * (double) 2.0 * 25.067525);
      *xdeg = *xdeg * 10.0;
      *ydeg = *ydeg * 10.0;
      *a0 = *a0 * 10.0;
      *b0 = *b0 * 10.0;
      break;
    default:
      fprintf(stderr,"\n *** Unrecognized SIR option in read_sir_header ***\n");
   }

   *nhead = temp[40];
   if (*nhead == 0) *nhead=1;
   *ndes = temp[41];
   *ldes = temp[42];
   *nia = temp[43];
   *ipol = temp[44];
   *ifreqhm = temp[45];
   *ispare1 = temp[46];
   *idatatype = temp[47];
   if (*idatatype == 0) *idatatype = 2;

   if (*iscale == 0) *iscale=1;
   soff = 32767.0/(float) *iscale;
   if (*idatatype == 1) soff = 128.0/(float) *iscale;

   *anodata = (float) temp[48]/(float) *iscale + *ioff + soff;
   *v_min = (float) temp[49]/(float) *iscale + *ioff + soff;
   *v_max = (float) temp[50]/(float) *iscale + *ioff + soff;

   if (*idatatype == 4) {
#ifdef SWAP
     un.i2[1]=temp[51];
     un.i2[0]=temp[52];
     *anodata = un.f2;
     un.i2[1]=temp[53];
     un.i2[0]=temp[54];
     *v_min = un.f2;
     un.i2[1]=temp[55];
     un.i2[0]=temp[56];
     *v_max = un.f2;
#else
     un.i2[0]=temp[51];
     un.i2[1]=temp[52];
     *anodata = un.f2;
     un.i2[0]=temp[53];
     un.i2[1]=temp[54];
     *v_min = un.f2;
     un.i2[0]=temp[55];
     un.i2[1]=temp[56];
     *v_max = un.f2;
#endif
   }
   
   for (in = 0; in < 20; in++) {
      sensor[2*in] = temp[19+in] % 256;
      sensor[2*in+1] = temp[19+in]/256; 
   }
   sensor[40] = '\0';

   for (in = 0; in < 69; in++) {
      type[2*in] = temp[57+in] % 256;
      type[2*in+1] = temp[57+in]/256;
   }
   type[138] = '\0';

   for (in = 0; in < 40; in++) {
      title[2*in] = temp[128+in] % 256;
      title[2*in+1] = temp[128+in]/256;
   }
   title[80] = '\0';

   for (in = 0; in < 20; in++) {
      tag[2*in] = temp[169+in] % 256;
      tag[2*in+1] = temp[169+in]/256;
   }
   tag[40] = '\0';

   for (in = 0; in < 50; in++) {
      crproc[2*in] = temp[190+in] % 256;
      crproc[2*in+1] = temp[190+in]/256;
   }
   crproc[100] = '\0';

   for (in = 0; in < 14; in++) {
      crtime[2*in] = temp[241+in] % 256;
      crtime[2*in+1] = temp[241+in]/256;
   }
   crtime[28] = '\0';

   if (*nhtype == 1) {  
     *nhead=1;
     *ndes=0;
     *ldes=0;
     *nia=0;
     type[0]='\0';
     tag[0]='\0';
     crproc[0]='\0';
     crtime[0]='\0';
   }

   if (*nhead > 1) {   
      if (*ndes > 0) {
	 fseek(imf, 512, REL_BEGIN);
	 nch=(maxdes < *ldes ? maxdes : *ldes);
	 nch=0;
	 for (i = 0; i < *ndes; i++) {
	   if (fread(temp, sizeof(short), 256, imf) == 0) return(-1);
#ifdef SWAP
	   swap(temp, 256);
#endif
	   for (in = 0; in < 256; in++) {
	     if (nch < maxdes) descrip[nch] = temp[in] % 256;
	     nch++;
	     if (nch < maxdes) descrip[nch] = temp[in]/256;
	     nch++;
	   }
	 }
      }
      if (maxdes > 0) descrip[maxdes-1] = '\0';

      if (*nhead-*ndes-1 > 0) {
	 fseek(imf, 512*(*ndes+1), REL_BEGIN);
	 nch=(maxi < *nia ? maxi : *nia);
	 if (fread(iaopt, sizeof(short), nch, imf) == 0) return(-1);
#ifdef SWAP
	 swap(iaopt, nch);
#endif
      }
   }

   return(0);
}

*/

void print_head(int nhead, int ndes, int nhtype, int idatatype, int nsx,
		int nsy, float xdeg, float ydeg, float ascale,
		float bscale, float a0, float b0, 
		int ioff, int iscale, int iyear, int isday, int ismin,
		int ieday, int iemin, int iregion, int itype, int iopt,
		int ipol, int ifreqhm, int ispare1,
		float anodata, float v_min, float v_max,
		char *sensor, char *title, char *type, char *tag, char
		*crproc, char *crtime, 
		char *descrip, int ldes, short *iaopt, int nia)
{
  int i;

  if (nhtype < 20) fprintf(stdout,"  (Old style header) %d\n",nhtype);
  fprintf(stdout,"  Title:   '%s'\n",title);
  fprintf(stdout,"  Sensor:  '%s'\n",sensor);
  if (nhtype > 16) {
     fprintf(stdout,"  Type:    '%s'\n",type);
     fprintf(stdout,"  Tag:     '%s'\n",tag);
     fprintf(stdout,"  Creator: '%s'\n",crproc);
     fprintf(stdout,"  Created: '%s'\n",crtime);
  }
  fprintf(stdout,"  Size: %d x %d    Total:%d\n",nsx,nsy, nsx*nsy);
  fprintf(stdout,"  Offset: %d  Scale: %d\n",ioff,iscale);
  fprintf(stdout,"  Year: %d  JD range: %d-%d\n",iyear,isday,ieday);
  fprintf(stdout,"  Region Number: %d  Type: %d  Form: %d\n",iregion,itype,iopt);
  if (nhtype > 16) {
     fprintf(stdout,"  Polarization: %d  Frequency: %f MHz\n",ipol,ifreqhm*0.1);
     fprintf(stdout,"  Datatype: %d  Headers: %d  Ver:%d\n",idatatype,nhead,nhtype);
     fprintf(stdout,"  Nodata: %f\n   Vmin: %f  Vmax: %f\n",anodata,v_min,v_max);
     if (ldes > 0)
	fprintf(stdout,"  Description: (%d) '%s'\n",ldes,descrip);
     if (nia > 0) {
	fprintf(stdout,"  Extra Ints: %d\n",nia);
	for (i=0; i < nia; i++)
	   fprintf(stdout,"     %d %d",i,iaopt[i]);
     }	
  }

  switch(iopt) {
   case -1:
     fprintf(stdout,"  Rectangular image-only: \n");
     fprintf(stdout,"   Xspan,  Yspan:  %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   Xscale, Yscale: %f , %f\n",ascale,bscale);
     fprintf(stdout,"   Xorg,   Yorg:   %f , %f\n",a0,b0);
     break;

   case 0:
     fprintf(stdout,"  Rectangular Lat/Long form: \n");
     fprintf(stdout,"   Size (deg):     %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   Lon, Lat scale: %f , %f (pix/deg)\n",ascale,bscale);
     fprintf(stdout,"   Offsets:        %f , %f\n",a0,b0);
     break;

   case 2:
     fprintf(stdout,"  Lambert form: (local radius used)\n");
   case 1:
     if (iopt==1) fprintf(stdout,"  Lambert form:\n");
     fprintf(stdout,"   Center point:      %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   Lon, Lat scale:    %f , %f (km/pix)\n",1./ascale,1./bscale);
     fprintf(stdout,"   Lower-Left Corner: %f , %f\n",a0,b0);
     break;

   case 5:
     fprintf(stdout,"  Polar sterographic form: \n");
     fprintf(stdout,"   Center Lon,Lat:    %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   X,Y scales:        %f , %f (km/pix)\n",ascale,bscale);
     fprintf(stdout,"   Lower-Left Corner: %f , %f\n",a0,b0);
     break;

   case 11:
   case 12:
     fprintf(stdout,"  EASE polar azimuthal form: \n");
     fprintf(stdout,"   Map center (col,row): %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   A,B scales:           %f , %f\n",ascale,bscale);
     fprintf(stdout,"   Map origin (col,row): %f , %f\n",a0,b0);
     break;

   case 13:
     fprintf(stdout,"  EASE cylindrical form: \n");
     fprintf(stdout,"   Map center (col,row): %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   A,B scales:           %f , %f\n",ascale,bscale);
     fprintf(stdout,"   Map origin (col,row): %f , %f\n",a0,b0);
     break;

   default:
     fprintf(stdout,"  Unrecognized SIR file option: \n");
     fprintf(stdout,"   Xspan,  Yspan:  %f , %f\n",xdeg,ydeg);
     fprintf(stdout,"   Xscale, Yscale: %f , %f\n",ascale,bscale);
     fprintf(stdout,"   Xorg,   Yorg:   %f , %f\n",a0,b0);
     break;
  }
  
  fprintf(stdout,"  Image Min, Max: %f , %f\n\n",v_min,v_max);
  return;
}


void print_sir_header(struct sirheader h)
{
	fprintf(stdout,"SIR file header: \n");
	print_head(h.num_headers, h.num_desc, h.headertype, h.datatype, 
		h.xpixels, h.ypixels, h.xdegrees, h.ydegrees, h.xscale, h.yscale,
		h.olon, h.olat, h.ioff, h.iscale, 
		h.year, h.sday, h.smin, h.eday, h.emin, 
		h.region, h.image_type, h.proj_type, h.polarization, h.frequency,h.spare1,
		h.nodata, h.v_min, h.v_max,
		h.sensor, h.title, h.type, h.tag, h.crproc, h.crtime, 
		h.description, h.len_desc, (short*)"\0", h.num_opts);  
}


void swap(short *i, int n)   /* byte swap short (2 byte) integers */
{
   char *s, t;
   int j;
   
   for (j = 0; j < n; j++) {
     s = (char *) (i+j);
     t = *s;
     *s = *(s+1);
     *(s+1) = t;
   }
   return;
}

#ifndef SWAP
void swapi(int *i, int n)  /* byte swap long (4 byte) integers */
{
   char *s, t, t1;
   int j;
   
   for (j = 0; j < n; j++) {
     s = (char *) (i+j);
     t = *s;
     t1 = *(s+1);
     *s = *(s+3);
     *(s+1) = *(s+2);
     *(s+2) = t1;
     *(s+3) = t;
   }
   return;
}
#endif








/* Version 3 of SIR header */
/* standard sir file format read routines */
	    
int read_sir_header3(FILE *imf, int *nhead, int *ndes, int *nhtype,
		    int *idatatype, int *nsx, int *nsy, 
		    float *xdeg, float *ydeg, 
		    float *ascale, float *bscale, float *a0, float *b0, 
		    int *ixdeg_off, int *iydeg_off, int *ideg_sc,
		    int *iscale_sc, int *ia0_off, int *ib0_off, int *i0_sc,
		    int *ioff, int *iscale, int *iyear, 
		    int *isday, int *ismin, int *ieday, int *iemin, 
		    int *iregion, int *itype, int *iopt,
		    int *ipol, int *ifreqhm, int *ispare1,
		    float *anodata, float *v_min, float *v_max,
		    char *sensor, char *title, char *type, char *tag,
		    char *crproc, char *crtime, int maxdes, 
		    char *descrip, int *ldes, int maxi, short *iaopt,
		    int *nia)
{
   /* v3 read header of BYU SIR file --- written by D.Long Oct 2000 */

/*  Header consists of a variable number of 512 byte blocks.  The
    block contains scaling information and strings:
    note that character strings may or may not be null terminated in file

    The first block consists of 256 short integers.  Indexing them
    from 1..256 in an array temp, they contain:


	temp(1)	= nsx			! pixels in x direction
	temp(2) = nsy			! pixels in y direction
        temp(3) <= xdeg			! span of x
	temp(4) <= ydeg			! span of y
	temp(5) = nhtype                ! header type (old<15,20,30)
	temp(6) <= ascale               ! x scaling
	temp(7) <= bscale               ! y scaling
	temp(8) <= a0                   ! x (or lon) origin
         note: longitudes should be in the range -180 to 180
	temp(9) <= b0                   ! y (or lat) origin
         note: latitudes should be in the range -90 to 90

     scaling for prorjection parameters are generally:

        temp(3) = nint((xdeg + float(ixdeg_off)) * float(ideg_sc))
        temp(4) = nint((ydeg + float(iydeg_off)) * float(ideg_sc))
        temp(6) = nint(ascale * float(iscale_sc))
        temp(7) = nint(bscale * float(iscale_sc))
        temp(8) = nint((a0 + float(ia0_off)) * float(i0_sc))
        temp(9) = nint((b0 + float(ib0_off)) * float(i0_sc))

     with the following projection specific exceptions:

	if (iopt.eq.1.or.iopt.eq.2) then		! lambert
           temp(6) = nint(float(iscale_sc)/ascale)
           temp(7) = nint(float(iscale_sc)/bscale)
	if (iopt.eq.11.or.iopt.eq.12.or.iopt.eq.13) then ! EASE grid
           temp(6) = nint(float(iscale_sc)*anint(10.*ascale*
     *                         25.067525/6371.228)*0.05)
           temp(7) = nint(float(iscale_sc)*anint(10.*bscale/
     *                         25.067525)*0.05)

	temp(10) = ioff			! offset to be added to scale val
	temp(11) = iscale		! scale factor ival=(val-ioff)/iscale
	temp(12) = iyear		! year for data used
	temp(13) = isday		! starting JD
	temp(14) = ismin		! time of day for first data (in min)
	temp(15) = ieday		! ending JD
	temp(16) = iemin		! time of day for last data (in min)
	temp(17) = iopt			! projection type
					!  -1 = no projection, image only
					!   0 = rectalinear lat/lon
					!   1 = lambert equal area
					!   2 = lambert equal area (local rad)
					!   5 = polar stereographic
					!  11 = EASE north equal area grid
					!  12 = EASE south equal area grid
					!  13 = EASE cylindrical grid
	temp(18) = iregion		! region id code
	temp(19) = itype		! image type code
                                       ! some standard values: (0=unknown)
                                       ! 1 = scatterometer A (dB)
                                       ! 2 = scatterometer B (dB/deg)
                                       ! 3 = radiometer Tb (K)
                                       ! 9 = topography (m)
	temp(20)-temp(39) 40 chars of sensor
        temp(40) = iscale_sc            ! ascale/bscale scale factor
        temp(41) = nhead                ! number of 512 byte header blocks
        temp(42) = ndes                 ! number of 512 byte blocks description
        temp(43) = ldes                 ! number of bytes of description
        temp(44) = nia                  ! number of optional integers
        temp(45) = ipol                 ! polarization (0=n/a,1=H,2=V)
        temp(46) = ifreqhm              ! frequency in 100's MHz (0 if n/a)
        temp(47) = ispare1              ! spare
        temp(48) = idatatype            ! data type code 0,2=i*2,1=i*1,4=float

       the value of idata type determines how data is stored and how
       anodata, vmin, and vmax are stored.

       if idatatype = 1 data is stored as bytes (minv=128)
       if idatatype = 2 data is stored as 2 byte integers (minv=32766)
       if idatatype = 4 data is stored as IEEE floating point

       if idatatype = 1,2 anodata,vmin,vmax are stored as 2 byte integers
         in temp(49)..temp(51)  minv, ioff and iscal used to convert
         integers or bytes into floating point values
         nodata, vmin, and vmax must be representable with ioff and iscale
            temp(*) = (value-ioff)*iscale-minv
            value = float(temp(*)+minv)/float(iscale)+ioff
       idatatype=2 is considered the SIR standard format

       if idatatype = f anodata,vmin,vmax are stored as floating points
         in temp(42)..temp(57) and minv, ioff and iscale are ignored here
         and when reading the file.
         floating point numbers are NOT standard across platforms and
         are therefore not recommended

        temp(49) <= anodata           ! value representing no data
        temp(50) <= vmin              ! minimum useful value from creator prg
        temp(51) <= vmax              ! maximum useful value from creator prg
        temp(52,53) = anodata         ! IEEE floating value of no data
        temp(54,55) = vmin            ! IEEE floating minimum useful value
        temp(56,57) = vmax            ! IEEE floating maximum useful value

        temp(58)-temp(126) 150 chars of type
        temp(127) = ixdeg_off         ! xdeg offset
        temp(128) = iydeg_off         ! ydeg offset
        temp(129)-temp(168) 80 chars of title
        temp(169) = ideg_sc           ! xdeg,ydeg scale factor
        temp(170)-temp(189) 40 chars of tag
        temp(190) = ia0_off           ! b0 offset 
        temp(191)-temp(240) 100 chars of crproc
        temp(241) = ib0_off           ! b0 offset 
        temp(242)-temp(255) 28 chars of crtime
        temp(256) = i0_sc             ! a0,b0 scale factor

     optional header blocks:

       ndes header blocks of 512 bytes: chars of description
       nhead-ndes-1 header blocks of 512 bytes: values of iaopt
        by convention, first value iaopt is a code telling how to interpret
        the rest of the array if nia>0.  Usage of additional blocks is
        user dependent and non-standard.

       remainder of file is image data in a multiple of 512 byte blocks

       one,two byte integer scaling (idatatype=1,2) is
          intval = (fvalue-ioff)*iscale-minv
          fvalue = float(intval+minv)/float(iscale)+ioff
       no scaling of float values for (idatatype=4)

*/

   short in, temp[256];
   int nch,i;
   float soff;

   union {
     short i2[2];
     float f2;
   } un;

   rewind(imf);  /* make sure to be start of file */

/* read first header block */

   if (fread(temp, sizeof(short), 256, imf) == 0) return(-1);
#ifdef SWAP
   swap(temp, 256);
#endif

/* decode nsx */

   *nsx = temp[0];
   *nsy = temp[1];
   *iopt  = temp[16];
   *nhtype = temp[4];

   if (*nhtype < 20) *nhtype=1;

   if (*nhtype < 30) {  /* set version 3.0 parameters to default version 2.0 values */

     switch (*iopt){
     case -1: /* image only */
       *ideg_sc=10;
       *iscale_sc=1000;
       *i0_sc=100;
       *ixdeg_off=0;
       *iydeg_off=0;
       *ia0_off=0;
       *ib0_off=0;
       break;
     case 0: /* rectalinear lat/lon */
       *ideg_sc=100;
       *iscale_sc=1000;
       *i0_sc=100;
       *ixdeg_off=-100;
       *iydeg_off=0;
       *ia0_off=0;
       *ib0_off=0;
       break;
     case 1: /* lambert */
     case 2:
       *ideg_sc=100;
       *iscale_sc=1000;
       *i0_sc=1;
       *ixdeg_off=0;
       *iydeg_off=0;
       *ia0_off=0;
       *ib0_off=0;
       break;
     case 5: /* polar stereographic */
       *ideg_sc=100;
       *iscale_sc=100;
       *i0_sc=1;
       *ixdeg_off=-100;
       *iydeg_off=0;
       *ia0_off=0;
       *ib0_off=0;
       break;
     case 11: /* EASE grid */
     case 12:
     case 13:
       *ideg_sc=10;
       *iscale_sc=1000;
       *i0_sc=10;
       *ixdeg_off=0;
       *iydeg_off=0;
       *ia0_off=0;
       *ib0_off=0;
       break;
     default: /* unknown */
       *ideg_sc=100;
       *iscale_sc=1000;
       *i0_sc=100;
       *ixdeg_off=0;
       *iydeg_off=0;
       *ia0_off=0;
       *ib0_off=0;
     }

   } else {  /* get projection offset and scale factors from file */
     
     *iscale_sc = temp[ 39];
     *ixdeg_off = temp[126];
     *iydeg_off = temp[127];
     *ideg_sc   = temp[168];
     *ia0_off   = temp[189];
     *ib0_off   = temp[240];
     *i0_sc     = temp[255];

   }

   /* decode default projection parameters */

   *xdeg = temp[2] / (float) *ideg_sc - *ixdeg_off;
   *ydeg = temp[3] / (float) *ideg_sc - *iydeg_off;
   *ascale = temp[5] / (float) *iscale_sc;
   *bscale = temp[6] / (float) *iscale_sc;
   *a0 = temp[7] / (float) *i0_sc - *ia0_off;
   *b0 = temp[8] / (float) *i0_sc - *ib0_off;

   /* handle special cases which depend on transformation option */

   switch (*iopt){
   case -1: /* image only */
     break;
   case 0:  /* rectalinear lat/lon */
     break;
   case 1:  /* lambert */
   case 2:
     *ascale = (float) *iscale_sc / (float) temp[5];
     *bscale = (float) *iscale_sc / (float) temp[6];
     break;
   case 5:  /* polar stereographic */
     break;
   case 11: /* EASE grid */
   case 12:
   case 13:
     *ascale = 2.0L*((double) temp[5] / (double) *iscale_sc) * 6371.228L/25.067525L;
     *bscale = 2.0L*((double) temp[6] / (double) *iscale_sc) * 25.067525L;
     break;
   default:
     fprintf(stderr,"\n *** Unrecognized SIR option in read_sir_header3 ***\n");
   }


   *ioff = temp[9];
   *iscale = temp[10];
   if (*iscale == 0) *iscale=1;

   *iyear = temp[11];
   *isday = temp[12];
   *ismin = temp[13];
   *ieday = temp[14];
   *iemin = temp[15];

   *iregion = temp[17];
   *itype = temp[18];

   *nhead = temp[40];
   if (*nhead == 0) *nhead=1;
   *ndes = temp[41];
   *ldes = temp[42];
   *nia = temp[43];
   *ipol = temp[44];
   *ifreqhm = temp[45];
   *ispare1 = temp[46];
   *idatatype = temp[47];
   if (*idatatype == 0) *idatatype = 2;

   if (*iscale == 0) *iscale=1;
   soff = 32767.0/(float) *iscale;
   if (*idatatype == 1) soff = 128.0/(float) *iscale;

   *anodata = (float) temp[48]/(float) *iscale + *ioff + soff;
   *v_min = (float) temp[49]/(float) *iscale + *ioff + soff;
   *v_max = (float) temp[50]/(float) *iscale + *ioff + soff;

   if (*idatatype == 4) {

#ifdef SWAP
     un.i2[1]=temp[51];
     un.i2[0]=temp[52];
     *anodata = un.f2;
     un.i2[1]=temp[53];
     un.i2[0]=temp[54];
     *v_min = un.f2;
     un.i2[1]=temp[55];
     un.i2[0]=temp[56];
     *v_max = un.f2;
#else
     un.i2[0]=temp[51];
     un.i2[1]=temp[52];
     *anodata = un.f2;
     un.i2[0]=temp[53];
     un.i2[1]=temp[54];
     *v_min = un.f2;
     un.i2[0]=temp[55];
     un.i2[1]=temp[56];
     *v_max = un.f2;
#endif

   }
   
   for (in = 0; in < 20; in++) {
      sensor[2*in] = temp[19+in] % 256;
      sensor[2*in+1] = temp[19+in]/256; 
   }
   sensor[40] = '\0';

   for (in = 0; in < 69; in++) {
      type[2*in] = temp[57+in] % 256;
      type[2*in+1] = temp[57+in]/256;
   }
   type[138] = '\0';

   for (in = 0; in < 40; in++) {
      title[2*in] = temp[128+in] % 256;
      title[2*in+1] = temp[128+in]/256;
   }
   title[80] = '\0';

   for (in = 0; in < 20; in++) {
      tag[2*in] = temp[169+in] % 256;
      tag[2*in+1] = temp[169+in]/256;
   }
   tag[40] = '\0';

   for (in = 0; in < 50; in++) {
      crproc[2*in] = temp[190+in] % 256;
      crproc[2*in+1] = temp[190+in]/256;
   }
   crproc[100] = '\0';

   for (in = 0; in < 14; in++) {
      crtime[2*in] = temp[241+in] % 256;
      crtime[2*in+1] = temp[241+in]/256;
   }
   crtime[28] = '\0';

   if (*nhtype == 1) {  /* a really old style header */
     *nhead=1;
     *ndes=0;
     *ldes=0;
     *nia=0;
     type[0]='\0';
     tag[0]='\0';
     crproc[0]='\0';
     crtime[0]='\0';
     *nhtype=20;   /* upgrade style on read */
   }

   if (*nhead > 1) {   /* read additional header blocks */
      if (*ndes > 0) {
	if (*ldes >= maxdes)
	  fprintf(stderr,"*** read_sir_head3 warning: file description too short (needed: %d avail: %d)\n",*ldes, maxdes);

	 fseek(imf, 512, REL_BEGIN);
	 nch=(maxdes < *ldes ? maxdes : *ldes);
	 nch=0;
	 for (i = 0; i < *ndes; i++) {
	   if (fread(temp, sizeof(short), 256, imf) == 0) return(-1);
#ifdef SWAP
	   swap(temp, 256);
#endif
	   for (in = 0; in < 256; in++) {
	     if (nch < maxdes) descrip[nch] = temp[in] % 256;
	     nch++;
	     if (nch < maxdes) descrip[nch] = temp[in]/256;
	     nch++;
	   }
	 }
      }
      if (maxdes > 0) descrip[maxdes-1] = '\0';

      if (*nhead-*ndes-1 > 0) {
	 fseek(imf, 512*(*ndes+1), REL_BEGIN);
	 if (*nia >= maxi)
	   fprintf(stderr,"*** read_sir_head3 warning: header extra ints too short (needed: %d avail: %d)\n",*nia, maxi);

	 nch=(maxi < *nia ? maxi : *nia);
	 if (fread(iaopt, sizeof(short), nch, imf) == 0) return(-1);
#ifdef SWAP
	 swap(iaopt, nch);
#endif
      }
   }

   return(0);
}







int read_sir_header(FILE *imf, struct sirheader *h)
{
	int xdegrees_offset, ydegrees_offset, degrees_scale, scale_scale;
	int olon_scale, olat_scale, i0_scale;
	char temp[50];
	int i1, i2, i3, i4;
	read_sir_header3(imf, &(h->num_headers), &(h->num_desc), &(h->headertype),
		&(h->datatype), &(h->xpixels), &(h->ypixels),
		&(h->xdegrees), &(h->ydegrees), &(h->xscale), &(h->yscale), 
		&(h->olon), &(h->olat),
		&xdegrees_offset, &ydegrees_offset, &degrees_scale, &scale_scale,
		&olon_scale, &olat_scale, &i0_scale,
		&(h->ioff), &(h->iscale),
		&(h->year), &(h->sday), &(h->smin), &(h->eday), &(h->emin),
		&(h->region), &(h->image_type), &(h->proj_type),
		&(h->polarization), &(h->frequency), &(h->spare1),
		&(h->nodata), &(h->v_min), &(h->v_max),
		h->sensor, h->title, h->type, h->tag,
		h->crproc, h->crtime,
		40, temp, &i1,
		0, 0, &i3);		
}






/* v2 read header of BYU SIR file --- written by D.Long March 1997 */
/*
	Updated by Vaughn C. Clayton August 2000
	todo: byte ordering checks/conversions
*/
int read_sir_header_old(FILE *imf, struct sirheader *h)
{
	struct sirfileheader fh;
	int i;
	float soff;
	char c;
	
	rewind(imf);

/* read first header block */
   if (fread(&fh, 2, 256, imf) == 0) return(-1);

	h->xpixels = fh.xpixels;
	h->ypixels = fh.ypixels;
	h->xdegrees = 0.01 * fh.xdegrees;
	h->ydegrees = 0.01 * fh.ydegrees;
	h->headertype = fh.headertype < 20 ? 1 : fh.headertype;
	h->xscale = 0.001 * fh.xscale;
	h->yscale = 0.001 * fh.yscale;
	h->olon = 0.01 * fh.olon;
	h->olat = 0.01 * fh.olat;
	h->ioff = fh.ioff;
	h->iscale = fh.iscale == 0 ? 1 : fh.iscale;
	h->year = fh.year;
	h->sday = fh.sday;
	h->smin = fh.smin;
	h->eday = fh.eday;
	h->emin = fh.emin;
	h->proj_type = fh.proj_type;
	h->region = fh.region;
	h->image_type = fh.image_type;

//	printf("%d\n", h->proj_type);
//	swap(&h->proj_type, 1);
//	printf("%d\n", h->proj_type);
	
	switch (h->proj_type)
	{
		case -1:
			h->xdegrees *= 10.0;
			h->ydegrees *= 10.0;
			break;
		case 0:
			h->xdegrees += 100.0;
			break;
		case 1:
		case 2:
			h->xscale = 1.0 / h->xscale;
			h->yscale = 1.0 / h->yscale;
			h->olon *= 100.0;
			h->olat *= 100.0;
			break;
		case 5:
			h->xscale *= 10.0;
			h->yscale *= 10.0;
			h->olon *= 100.0;
			h->olat *= 100.0;
			h->xdegrees += 100.0;
			break;
		case 11:
		case 12:
		case 13:
			h->xscale = ( ((double)h->xscale) * (double)2.0 * 6371.228/25.067525 );
			h->yscale = ( ((double)h->yscale) * (double)2.0 * 25.067525);
			h->xdegrees *= 10.0;
			h->ydegrees *= 10.0;
			h->olon *= 10.0;
			h->olat *= 10.0;
			break;
		default:
			fprintf(stderr,"\n *** Unrecognized SIR option in read_sir_header_2 ***\n");
	}
	h->num_headers = fh.num_headers == 0 ? 1 : fh.num_headers;
	h->num_desc = fh.num_desc;
	h->len_desc = fh.len_desc;
	h->num_opts = fh.num_opts;
	h->polarization = fh.polarization;
	h->frequency = fh.frequency;
	h->spare1 = fh.spare1;
	h->datatype = fh.datatype == 0 ? 2 : fh.datatype;
	
	soff = 32767.0 / (float)h->iscale;
	if (h->datatype == 1) soff = 128.0 / (float)h->iscale;
   
	h->nodata = (float)fh.inodata / (float)h->iscale + h->ioff + soff;
	h->v_min = (float)fh.imin / (float)h->iscale + h->ioff + soff;
	h->v_max = (float)fh.imax / (float)h->iscale + h->ioff + soff;

	if(h->datatype == 4)
	{
		h->nodata = *((float*)&fh.fnodata);
		h->v_min = *((float*)&fh.fmin);
		h->v_max = *((float*)&fh.fmax);
	}
	

	// Put the *silly* strings into a NORMAL byte order (Oy!)
	for(i=0; i<40; i+=2) { c=fh.sensor[i]; fh.sensor[i]=fh.sensor[i+1]; fh.sensor[i+1]=c;}
	for(i=-2; i<138; i+=2) { c=fh.type[i]; fh.type[i]=fh.type[i+1]; fh.type[i+1]=c;}
	for(i=0; i<80; i+=2) { c=fh.title[i]; fh.title[i]=fh.title[i+1]; fh.title[i+1]=c;}
	for(i=0; i<40; i+=2) { c=fh.tag[i]; fh.tag[i]=fh.tag[i+1]; fh.tag[i+1]=c;}
	for(i=0; i<100; i+=2) { c=fh.crproc[i]; fh.crproc[i]=fh.crproc[i+1]; fh.crproc[i+1]=c;}
	for(i=0; i<28; i+=2) { c=fh.crtime[i]; fh.crtime[i]=fh.crtime[i+1]; fh.crtime[i+1]=c;}
	fh.null1=fh.null3=fh.null4=fh.null5=fh.null6=fh.null7=0;
	strncpy(h->sensor, fh.sensor, 40);
	strncpy(h->type, fh.type, 138);
	strncpy(h->title, fh.title, 80);
	strncpy(h->tag, fh.tag, 40);
	strncpy(h->crproc, fh.crproc, 100);
	strncpy(h->crtime, fh.crtime, 28);
	h->sensor[40]=0;
	h->type[138]=0;
	h->title[80]=0;
	h->tag[40]=0;
	h->crproc[100]=0;
	h->crtime[28]=0;
/*
   if (*nhtype == 1) {  // old style header
     *nhead=1;
     *ndes=0;
     *ldes=0;
     *nia=0;
     type[0]='\0';
     tag[0]='\0';
     crproc[0]='\0';
     crtime[0]='\0';
   }
*/

/*
	// read additional header blocks 
   if (*nhead > 1) {   
      if (*ndes > 0) {
	 fseek(imf, 512, REL_BEGIN);
	 nch=(maxdes < *ldes ? maxdes : *ldes);
	 nch=0;
	 for (i = 0; i < *ndes; i++) {
	   if (fread(temp, sizeof(short), 256, imf) == 0) return(-1);
#ifdef SWAP
	   swap(temp, 256);
#endif
	   for (in = 0; in < 256; in++) {
	     if (nch < maxdes) descrip[nch] = temp[in] % 256;
	     nch++;
	     if (nch < maxdes) descrip[nch] = temp[in]/256;
	     nch++;
	   }
	 }
      }
      if (maxdes > 0) descrip[maxdes-1] = '\0';

      if (*nhead-*ndes-1 > 0) {
	 fseek(imf, 512*(*ndes+1), REL_BEGIN);
	 nch=(maxi < *nia ? maxi : *nia);
	 if (fread(iaopt, sizeof(short), nch, imf) == 0) return(-1);
#ifdef SWAP
	 swap(iaopt, nch);
#endif
      }
   }
*/
	return(0);
}



/*
	The user is responsible for allocating storage space before calling this
	function! The size required is header.xpixels*header.ypixels*sizeof(float).
*/
int read_sir_data(FILE *imf, float *data)
{
	struct sirheader h;
	int x, y;
//	char *buf;
	int width, height;
	float smin, smax, amag;
	float s, soff;
	short *a;
	float fmin, fmax;
	
	read_sir_header(imf, &h);
	rewind(imf);

	width = h.xpixels;
	height = h.ypixels;

	
	if (h.headertype < 20) // old style header 
	{  
	//	fprintf(stdout," (Old style header) %d\n",nhtype);
		h.v_min=-32.0;
		h.v_max=0;
		h.nodata=-32.0;
		h.datatype=2;
	}


	smin = h.v_min;
	smax = h.v_max;

//	if (argc > 3) sscanf(argv[3],"%f",&smin); 
//	if (argc > 4) sscanf(argv[4],"%f",&smax); 
	if (smax - smin == 0.0) smax = smin + 1.0;


//	a =(short *) malloc(sizeof(short)*width);
//	data = (char *) malloc(sizeof(char)*width*nlines);
//	stval = (float *) malloc(sizeof(float)*width*nlines);
//	if (a == NULL || data == NULL || stval == NULL) 
//	{
//		fprintf(stderr,"*** ERROR: memory allocation failure...\n");
//		exit(-1);
//	}

  s = 1.0 / ((float) h.iscale);
  soff = 32767.0/ ((float) h.iscale) + ((float) h.ioff);
  if (h.datatype == 1) soff = 128.0/ ((float) h.iscale) + ((float) h.ioff);

//	printf("iscale: %d\n", h.iscale);
//	printf("ioff: %d\n", h.ioff);
//	printf("s: %f\n", s);
//	printf("soff: %f\n", soff);

//  scale = (smax-smin);
//  if (scale > 0.) scale = 255./ scale;
//  scaleoffset = smin;


	fseek(imf,sizeof(struct sirfileheader)*h.num_headers,REL_BEGIN);
  
	if(h.datatype==0) h.datatype = 2;
	if(h.datatype!=1 && h.datatype!=2 && h.datatype!=4)
	{
		fprintf(stderr, "read_sir_data() Error: Unknown data type.\n");
		return(-1);
	}
	a = (short*)malloc(4 * width);

	fmin = 100.0;
	fmax = -100.0;
	for (y = 0; y < height; y++) 
	{
		switch(h.datatype) 
		{
			case 1:     // bytes 
				fread((char *)a, sizeof(char), width, imf);
				for (x=0; x<width; x++)
				{
//					amag = ((float) a[j]) * s + soff; // pixel value 
					amag = ((float)a[x]);
					data[x+y*width] = amag;    // floating point array
				}
				break;
			case 4:     // floats
#ifdef SWAP
				fread((char *)a, sizeof(short), 2*width, imf) ;
				swap(a,width);
				for (x=0; x<width; x++)
				{
					un.i2[1]=a[x*2];
					un.i2[0]=a[x*2+1];
					amag = un.f2;
					data[x+y*width] = amag;  // floating point array
				}
#else
				fread((char *) (data+y*width), sizeof(float), width, imf);
#endif
				break;      
			default:    // 0 or 2: read two byte integers 
				fread((char *)a, sizeof(short), width, imf);
#ifdef SWAP	
				swap(a,width);
#endif
				for (x=0; x<width; x++)
				{
					amag = ((float) a[x]) * s + soff; // pixel value
					if(amag > fmax) fmax = amag;
					if(amag < fmin) fmin = amag;
					data[x+y*width] = amag;      // floating point array
				}	
		}
	}
	return 0;
}





int write_sir_header(FILE *imf, char *title, char *anont,
	       int nsx, int nsy, float xdeg, float ydeg, 
	       float ascale, float bscale, float a0, float b0, 
	       int ioff, int iscale, int iyear, int isday, int ismin,
	       int ieday, int iemin, int iregion, int itype, int iopt,
	       short iaopt[128])
{
   /* write header of BYU SIR file --- written by D.Long Dec. 1996 */

   short in;
   char temp, t[80];
   int i;

/* prescale copies of variables */

   switch (iopt){
    case -1:
      xdeg = xdeg * 0.1;
      ydeg = ydeg * 0.1;
      break;
    case 0:
      xdeg = xdeg - 100.0;
      break;
    case 1:
    case 2:
      ascale = 1./ ascale;
      bscale = 1./ bscale;
      a0 = a0 * 0.01;
      b0 = b0 * 0.01;
      break;
    case 5:
      ascale = ascale * 0.1;
      bscale = bscale * 0.1;
      a0 = a0 * 0.01;
      b0 = b0 * 0.01;
      xdeg = xdeg - 100.0;
      break;
    case 11:
    case 12:
    case 13:
      ascale = (float)(((double) ascale) /(2.0 * (double) 6371.228 / (double) 25.067525));
      bscale = (float)(((double) bscale) /(2.0 * (double) 25.067525));
      xdeg = xdeg * 0.1;
      ydeg = ydeg * 0.1;
      a0 = a0 * 0.1;
      b0 = b0 * 0.1;
      break;
    default:
      printf("\n *** Unrecognized SIR option in sir_header ***\n");
   }

   rewind(imf);

   in = nsx;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1); 

   in = nsy;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);
   
   in = xdeg * 100;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = ydeg * 100;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = 0;   /* extra space */
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = ascale * 1000.0;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = bscale * 1000.0;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = a0 * 100.0;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = b0 * 100.0;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = ioff;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = iscale;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = iyear;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = isday;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = ismin;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = ieday;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = iemin;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = iopt;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = iregion;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = itype;
#ifdef SWAP
   swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   for (in = 0; in < 40; in++)
      t[in] = anont[in];
   t[39] = '\0';
   for (in = 0; in < 20; in++) {
      temp = t[2*in];
      t[2*in] = t[2*in+1];
      t[2*in+1] = temp; 
   }
   if (fwrite(t, sizeof(char), 40, imf) != 40) return(-1); /* 20 */

   in = 0;
   for (i = 40; i < 128; i++)
      if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   in = iaopt[0];
#ifdef SWAP
      swap(&in);
#endif
   if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);

   for (in = 0; in < 80; in++)
      t[in] = title[in];
   t[79] = '\0';
   for (in = 0; in < 40; in++) {
      temp = t[2*in];
      t[2*in] = t[2*in+1];
      t[2*in+1] = temp; 
   }
   if (fwrite(t, sizeof(char), 80, imf) != 80) return(-1); /* 20 */

   for (i = 81; i < 128; i++) {
      in = iaopt[i];
#ifdef SWAP
      swap(&in);
#endif
      if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);
   }
   in = 0;
   for (i = 215; i < 256; i++)  /* should be 208 to 256 */
      if (fwrite(&in, sizeof(short), 1, imf) != 1) return(-1);
 
   return(0);
}





int putsir(char *fname, char *title, char *anont, int nsx, 
        int nsy, float xdeg, float ydeg, float ascale, float bscale,
	float a0, float b0, float *stval, int ioff, int iscale,
	int iyear, int isday, int ismin, int ieday, int iemin, 
	int iregion, int itype, int iopt, short *iaopt, int *ierr)
{
   FILE *imf;

   short a[10 * 600]; // Only needs to be  * 512, but just to be safe
   int i,j,k;
   long kk;
   float s, soff, am;
   int iunder = 0, iover = 0;
   
   imf = fopen(fname,"w");
   if (imf == NULL) {
      printf("*** Error opening file '%s'\n",fname);      
      *ierr = -1;
      return -1;
   }
   
/* write SIR image header information */

   *ierr = write_sir_header(imf, title, anont, nsx, nsy, 
		      xdeg, ydeg, 
		      ascale, bscale, a0, b0, ioff, iscale, iyear, 
		      isday, ismin,
		      ieday, iemin, iregion, itype, iopt, iaopt);
   if (*ierr < 0) {
      printf("*** Error writing file header '%s'\n",fname); 
      fclose(imf);
      *ierr = -1;
      return -1;
   }

   s = (float) iscale;
   soff = (float) ioff;

/* write file, converting floats to two byte integers */

   k = 0;
   for (i=0; i < nsy; i++) {
      for (j=0; j < nsx; j++) {
	 am = *(stval+k);
	 if (am > 1e23 || am < -1e23) {
	    printf("Oversize pixel value %f %d %d %d\n",am,i,j,k);
	    am = soff;
	 }
	 kk = (am - soff) * s;
	 kk = kk - 32767;
	 if (kk < -32767) {
	    kk = -32767;
	    iunder++;
	 }
	 if (kk > 32767) {
	    kk = 32767;
	    iover++;
	 }
/*	 printf("%d %d %d %d %f\n",i,j,k,kk+32767,am); */
	 
	 a[j] = kk;
#ifdef SWAP
	 swap(&a[j]);
#endif
	 k++;
      }
      if (fwrite((char *) a, sizeof(short), nsx, imf) != nsx) {
	 printf("*** Error writing data\n");
	 *ierr = -1;
	 fclose(imf);
	 return -1;
      }
   }

/* add zero pad to ensure file is a multiple of 512 bytes long */

   if (k % 512 != 0) {
      i = 512 - k % 512;
      for (j = 0; j < i; j++)
	 a[j] = 0;
      if (fwrite((char *) a, sizeof(short), i, imf) != i) {
	 printf("*** Error writing data\n");
	 *ierr = -1;
	 fclose(imf);
	 return -1;
      }
   }
	 
   fclose(imf);

   fprintf(stdout,"File successfully written in putsir\n");
   fprintf(stdout," Underflows: %d  Overflows: %d  Count: %d\n",iunder,iover,nsx*nsy);
   *ierr = 0;
   return 0;
}

	    




int write_sirheader(FILE *imf, struct sirheader h)
{
	struct sirfileheader fh;
	int i;
	float soff;
//	char c;
	union {
		float f;
		char c[4];
	} u;
	
//	printf("1\n");
	rewind(imf);
//	printf("2\n");



	switch (h.proj_type)
	{
		case -1:
			h.xdegrees *= 0.1;
			h.ydegrees *= 0.1;
			break;
		case 0:
			h.xdegrees -= 100.0;
			break;
		case 1:
		case 2:
			h.xscale = 1.0 / h.xscale;
			h.yscale = 1.0 / h.yscale;
			h.olon *= 0.01;
			h.olat *= 0.01;
			break;
		case 5:
			h.xscale *= 0.1;
			h.yscale *= 0.1;
			h.olon *= 0.01;
			h.olat *= 0.01;
			h.xdegrees -= 100.0;
			break;
		case 11:
		case 12:
		case 13:
			h.xscale = ( ((double)h.xscale) / ((double)2.0 * 6371.228/25.067525 ));
			h.yscale = ( ((double)h.yscale) / ((double)2.0 * 25.067525));
			h.xdegrees *= 0.1;
			h.ydegrees *= 0.1;
			h.olon *= 0.1;
			h.olat *= 0.1;
			break;
		default:
			fprintf(stderr,"\n *** Unrecognized SIR option in write_sirheader ***\n");
	}

//	printf("2.1\n");


	fh.xpixels = h.xpixels;
	fh.ypixels = h.ypixels;
	fh.xdegrees = h.xdegrees * 100.0;
	fh.ydegrees = h.ydegrees * 100.0;
	fh.headertype = h.headertype;
	fh.xscale = h.xscale * 1000.0;
	fh.yscale = h.yscale * 1000.0;
	fh.olon = h.olon * 100.0;
	fh.olat = h.olat * 100.0;
	fh.ioff = h.ioff;
	fh.iscale = h.iscale;
	fh.year = h.year;
	fh.sday = h.sday;
	fh.smin = h.smin;
	fh.eday = h.eday;
	fh.emin = h.emin;
	fh.proj_type = h.proj_type;
	fh.region = h.region;
	fh.image_type = h.image_type;

//	printf("2.2\n");


	fh.num_headers = h.num_headers;
	fh.num_desc = h.num_desc;
	fh.len_desc = h.len_desc;
	fh.num_opts = h.num_opts;
	fh.polarization = h.polarization;
	fh.frequency = h.frequency;
	fh.spare1 = h.spare1;
	fh.datatype = h.datatype;

//	printf("2.3\n");

	
	fh.inodata = h.nodata;
	fh.imin = h.v_min;
	fh.imax = h.v_max;
//	printf("2.4\n");
	for(i=0; i<4; i++)
	{
		u.f = h.nodata;
		fh.fnodata[i] = u.c[i];
		u.f = h.v_min;
		fh.fmin[i] = u.c[i];
		u.f = h.v_max;
		fh.fmax[i] = u.c[i];
	}


//	printf("3\n");

	soff = 32767.0 / (float)h.iscale;
	if (h.datatype == 1) soff = 128.0 / (float)h.iscale;
   
//	h->nodata = (float)fh.inodata / (float)h->iscale + h->ioff + soff;
//	h->v_min = (float)fh.imin / (float)h->iscale + h->ioff + soff;
//	h->v_max = (float)fh.imax / (float)h->iscale + h->ioff + soff;

	fh.inodata = rnd((h.nodata - (float)h.ioff - soff) * (float)h.iscale);
	fh.imin = rnd((h.v_min - (float)h.ioff - soff) * (float)h.iscale);
	fh.imax = rnd((h.v_max - (float)h.ioff - soff) * (float)h.iscale);

//	printf("4\n");

	strncpy(fh.sensor, h.sensor, 40);
	strncpy(fh.type, h.type, 138);
	strncpy(fh.title, h.title, 80);
	strncpy(fh.tag, h.tag, 40);
	strncpy(fh.crproc, h.crproc, 100);
	strncpy(fh.crtime, h.crtime, 28);
	fh.null1=fh.null3=fh.null4=fh.null5=fh.null6=fh.null7=0;

//	printf("5\n");

	// Put the strings back into the wierd byte order
	for(i=0; i<40; i+=2) { fh.sensor[i]=h.sensor[i+1]; fh.sensor[i+1]=h.sensor[i];}
	for(i=0; i<138; i+=2) { fh.type[i]=h.type[i+1]; fh.type[i+1]=h.type[i];}
	for(i=0; i<80; i+=2) { fh.title[i]=h.title[i+1]; fh.title[i+1]=h.title[i];}
	for(i=0; i<40; i+=2) { fh.tag[i]=h.tag[i+1]; fh.tag[i+1]=h.tag[i];}
	for(i=0; i<100; i+=2) { fh.crproc[i]=h.crproc[i+1]; fh.crproc[i+1]=h.crproc[i];}
	for(i=0; i<28; i+=2) { fh.crtime[i]=h.crtime[i+1]; fh.crtime[i+1]=h.crtime[i];}

//	printf("6\n");

	fh.null1=fh.null3=fh.null4=fh.null5=fh.null6=fh.null7=0;

//	printf("%d ", sizeof(fh));

//	printf("O");
	if(fwrite(&fh, 512, 1, imf)!=1) return -1;
//	printf("K\n");
	
	return(0);
}




int SaveSIR(char *fname, struct sirheader h, float *data)
{
   FILE *imf;

//	short a[10 * 600]; // Only needs to be  * 512, but just to be safe
	int i,j,k;
	long kk;
	float s, soff, am;
	int iunder = 0, iover = 0;
	short *a;
   
	a = (short*)malloc((h.xpixels+10) * sizeof(short));
   
	imf = fopen(fname,"wb");
	if (imf == NULL) 
	{
		fprintf(stderr, "*** Error opening file '%s' for writing\n",fname);      
		return -1;
	}
   
	printf("Writing header\n");
	/* write SIR image header information */
	if (write_sirheader(imf, h) < 0)
	{
		fprintf(stderr, "*** SaveSIR: Error writing file header '%s'\n",fname); 
		fclose(imf);
		return -1;
	}
	printf("Wrote header\n");

	
	s = (float) h.iscale;
	soff = (float) h.ioff;

	/* write file, converting floats to two byte integers */

	k = 0;
	for (i=0; i < h.ypixels; i++) 
	{
		for (j=0; j < h.xpixels; j++) 
		{
			am = *(data+k);
			if (am > 1e23 || am < -1e23) 
			{
				printf("Oversize pixel value %f %d %d %d\n",am,i,j,k);
				am = soff;
			}
			kk = (am - soff) * s;
			kk = kk - 32767;
			if (kk < -32767) 
			{
				kk = -32767;
				iunder++;
			}
			if (kk > 32767) 
			{
				kk = 32767;
				iover++;
			}
			/*printf("%d %d %d %d %f\n",i,j,k,kk+32767,am); */
	 
			a[j] = kk;
#ifdef SWAP
			swap(&a[j]);
#endif
			k++;
		}
		if (fwrite((char *) a, sizeof(short), h.xpixels, imf) != h.xpixels)
		{
			printf("*** Error writing data\n");
			fclose(imf);
			return -1;
		}
	}

	printf("Padding to 512-byte length\n");
/* add zero pad to ensure file is a multiple of 512 bytes long */
	if (k % 512 != 0) 
	{
		i = 512 - k % 512;
		for (j = 0; j < i; j++)
			a[j] = 0;
		if (fwrite((char *) a, sizeof(short), i, imf) != i) 
		{
			printf("*** Error writing data\n");
			fclose(imf);
			return -1;
		}
	}
	 
   fclose(imf);

   fprintf(stdout,"File successfully written in SaveSIR\n");
   fprintf(stdout," Underflows: %d  Overflows: %d  Count: %d\n",iunder,iover,h.xpixels*h.ypixels);
   return 0;
}


float *LoadSIR(char *filename, struct sirheader *h) 
{
    FILE *file;
    long size;                 /* size of the image in bytes. */
	float *data;
	
    /* make sure the file is there. */
	if ((file = fopen(filename, "rb"))==NULL) 
	{
		fprintf(stderr, "File Not Found : %s\n",filename);
		return NULL;
	}

	read_sir_header(file, h);
	size = h->xpixels * h->ypixels * sizeof(float);
	data = (float*)malloc(size);
	if(data==NULL)
	{
		fprintf(stderr, "Error allocating SIR data memory\n");
		return NULL;
	}
	read_sir_data(file, data);
	fclose(file);
			
    return data;
}


int match_topography(char *insir, char *top, char *outsir)
{
	FILE *file;
	struct sirheader ish, toph, osh;
	float *topdata, *topography;
	float lat1, lon1, float_x, float_y;
	int x, y, ix, iy;
	float fmax, fmin;

	if ((file = fopen(insir, "rb"))==NULL) 
	{
		fprintf(stderr, "File Not Found : %s\n", insir);
		return -1;
	}
	read_sir_header(file, &ish);
	fclose(file);


//	topdata = LoadSIR(insir, &toph);
	topdata = LoadSIR(top, &toph);
	if(topdata ==NULL)
	{
		printf("Error allocating raw topography data memory\n");
		return -1;
	}
	print_sir_header(toph);


	topography = (float*)malloc(ish.xpixels * ish.ypixels * sizeof(float));
	if(topography ==NULL)
	{
		printf("Error allocating topography memory\n");
		return -1;
	}


	
// Match topography to SIR, pixel by pixel
	printf("Matching topography");
	fmax=-10000;
	fmin=10000;
	for(x=0; x<ish.xpixels; x++)
	{
		for(y=0; y<ish.ypixels; y++)
		{
//			printf("X, Y: %d, %d\n", x, y);
			pixtolatlon(ish, (x+1), (y+1), &lat1, &lon1);
//			printf("Lat Lon: %f, %f\n", lat1, lon1);

			latlon2pix(toph, lat1, lon1, &float_x, &float_y);

			f2ipix(float_x, float_y, &ix, &iy, toph.xpixels, toph.ypixels);
//			printf("Float X, Float Y: %f, %f\n", float_x, float_y);
			ix = (int)float_x - 0.99999;
			iy = (int)float_y - 0.99999;
//			printf("iX, iY: %d, %d\n", ix, iy);
			
			topography[x + y*ish.xpixels] = 
				topdata[ ix + iy*toph.xpixels ];
				
			if(topography[x + y*ish.xpixels]<fmin) fmin=topography[x + y*ish.xpixels];
			if(topography[x + y*ish.xpixels]>fmax) fmax=topography[x + y*ish.xpixels];
		}
		printf(".");
		fflush(stdout);
	}
	printf("Done\n");
	printf("%f, %f\n", fmin, fmax);



	
	osh = ish;
	strcpy(osh.title, "Topography data");
	strcpy(osh.type, "Topography data");
	strcpy(osh.crproc, "libsir.c: match_topography()");
	osh.ioff = toph.ioff;
	osh.iscale = toph.iscale;
	osh.year = toph.year;
	osh.sday = toph.sday;
	osh.smin = toph.smin;
	osh.eday = toph.eday;
	osh.emin = toph.emin;
	osh.nodata = toph.nodata;
	osh.v_min = toph.v_min;
	osh.v_max = toph.v_max;

//	osh = toph;
//	osh.xpixels = ish.xpixels;
//	osh.ypixels = ish.ypixels;


	print_sir_header(osh);
	printf("Saving topography\n");
	y = SaveSIR(outsir, osh, topography);
	printf("Saved topography\n");
	
	
	return y;
}




short get_globe_byte(short *data, long fpos)
{
//	static long base=-1;
}


/* You give this function a SIR image, and the filename of the topology data */
int match_topography_from_globe(char *insir, char *globefile, char *outsir)
{
	FILE *file;
	struct sirheader ish, osh;//, toph;
	float *topography;
	float lat1, lon1, float_x, float_y;
	long x, y, ix, iy;
	float fmax, fmin, fval;
	short *topdata, ival;
	unsigned long fpos;

	if ((file = fopen(insir, "rb"))==NULL) 
	{
		fprintf(stderr, "File Not Found : %s\n", insir);
		fflush(stderr);
		return -1;
	}
	read_sir_header(file, &ish);
	fclose(file);



/*
	topdata = (short *)malloc(1866240000); // Wow. I hope this works.
	if(topdata ==NULL)
	{
		printf("Error allocating raw topography data memory\n");
	printf("Sleeping...\n");
		fflush(stdout);
	sleep(10);
		return -1;
	}
*/


//	topdata = (short*)malloc(0x2000000); // 32 Meg


//	printf("Sleeping...\n");
//	sleep(10);

	topography = (float*)malloc(ish.xpixels * ish.ypixels * sizeof(float));
	if(topography ==NULL)
	{
		printf("Error allocating topography memory\n");
	printf("Sleeping...\n");
		fflush(stdout);
//	sleep(10);
		return -1;
	}




	if((file = fopen(globefile, "rb"))==NULL)
	{
		fprintf(stderr, "File not found: %s\n", globefile);
		fflush(stderr);
		return -1;
	}
	
	
/*	
	printf("Loading huge topography dataset\n");
	if(fread(topdata, 2, 933120000, file)!=933120000)
	{
		printf("Error reading data\n");
		fflush(stdout);
		return -1;
	}
*/	



	
// Match topography to SIR, pixel by pixel
	printf("Matching topography");
	fmax=-10000;
	fmin=10000;
	for(x=0; x<ish.xpixels; x++)
	{
		for(y=0; y<ish.ypixels; y++)
		{
//			printf("X, Y: %d, %d\n", x, y);
			pixtolatlon(ish, (x+1), (y+1), &lat1, &lon1);
//			printf("Lat Lon: %f, %f\n", lat1, lon1);

			float_x = (lon1 + 180.0) / 8.333333333333333e-3;
			float_y = (90.0 - lat1) / 8.333333333333333e-3;
			
			ix = float_x;
			iy = float_y;
			if(ix >= 43200) ix-=43200;
			if(iy > 21600) iy-=21600;
			if(iy == 21600) iy=21599;

			iy = 21600-iy;
			
			fpos = (long)ix + (long)iy*43200L;
			fpos *= 2;

			fseek(file, fpos, SEEK_SET);
			fread(&ival, sizeof(short), 1, file);
			
			swap(&ival, 1);
			
			topography[x + y*ish.xpixels] = ival;
//				topdata[ ix + iy*43200 ];
				
			if(topography[x + y*ish.xpixels]<fmin) fmin=topography[x + y*ish.xpixels];
			if(topography[x + y*ish.xpixels]>fmax) fmax=topography[x + y*ish.xpixels];
		}
		printf(".");
		fflush(stdout);
	}
	fclose(file);
	printf("Done\n");
	printf("%f, %f\n", fmin, fmax);



	
	osh = ish;
	strcpy(osh.title, "GLOBE Topography data");
	strcpy(osh.type, "GLOBE Topography data");
	strcpy(osh.crproc, "libsir.c: match_topography_from_globe()");
/*
	osh.ioff = toph.ioff;
	osh.iscale = toph.iscale;
	osh.year = toph.year;
	osh.sday = toph.sday;
	osh.smin = toph.smin;
	osh.eday = toph.eday;
	osh.emin = toph.emin;
	osh.nodata = toph.nodata;
	osh.v_min = toph.v_min;
	osh.v_max = toph.v_max;
*/
	print_sir_header(osh);
	printf("Saving topography\n");
	y = SaveSIR(outsir, osh, topography);
	printf("Saved topography\n");
	
	
	return y;
}
